3 ### Build script for Debian packages
5 ### (c) 2008 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ### GNU General Public License for more details.
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
31 ### * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ### a `.git' directory in the project top-level, so that we can find it.
34 ### * The following `make' variables must be assigned in the top-level
35 ### Makefile, after `mdw-build' has constructed it.
37 ### distdir The name of the top-level project directory in the
38 ### source distribution, and the base name for
39 ### distribution archives; should be of the form
40 ### `PROJECT-VERSION'.
42 ### The following `make' targets must be available in the top-level
45 ### dist Write to $(distdir).tar.gz a source distribution of
48 ### distcheck As for `dist', but also build and test the project.
50 ### * The source distribution constructed by `make dist' must contain a file
51 ### $(distdir)/RELEASE containing the release name. This isn't currently
52 ### tested, but it might be later.
56 ###--------------------------------------------------------------------------
61 Usage: $0 [-vr] BUILDOPT
76 ## Parse simple options.
78 while getopts "hvr" opt; do
87 ## Parse the build options.
99 checkout) checkout=yes checkoutrev=HEAD ;;
100 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
101 nocheckout) checkout=no ;;
102 release) build=release ;;
103 norelease) build=test ;;
105 setup | distcheck | debian | upload | clean | vpath)
108 nosetup | nodistcheck | nodebian | noupload | noclean | novpath)
118 ## Parse DEB_BUILD_OPTIONS.
120 set -- $DEB_BUILD_OPTIONS
123 parallel=*) jobs=${opt#*=} ;;
128 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
130 ###--------------------------------------------------------------------------
131 ### Utility functions.
133 exec 3>&2 4>/dev/null 5>&2
138 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
148 release) fail "$*" ;;
149 *) notify 5 "??? $*" ;;
164 "$@" 2>&3 || fail "$1: exit $?"
167 run () { runx "$@" >&3; }
170 echo -n "(test $*)" >&4
171 if "$@" >&4 2>&4; then
180 ###--------------------------------------------------------------------------
183 ## Find the top-level package directory.
184 while [ ! -f configure.ac -a ! -f configure.in -a \
185 ! -f .links -a ! -d .git ]; do
188 fail "couldn't find top-level directory"
193 assign srcpath $(pwd)
195 ## Construct the output directory.
196 assign releasepath $srcpath/dist-$build
197 chmod -R +w $releasepath 2>/dev/null || :
198 rm -rf $releasepath 2>/dev/null || :
202 exec 4>$releasepath/mdw-build.log 3>&4 ||
203 fail "Failed to create log."
207 ## Do we have a Git repository?
208 case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
210 fail "Inconsistent options: can't check out without setup."
213 info "No Git repository found."
214 checkout=no gitver=none
218 [ "$(git ls-files -m)" = "" ] ||
219 warn "working tree has uncommitted changes"
220 gitver=$(git describe)
223 ## Is there Debian build equipment?
224 case "$debian,$(yesno [ -d $srcpath/debian ])" in
226 info "No debian directory found."
227 debian=no debver=none
230 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p')
234 ## Check the version number.
235 case "$gitver,$debver" in
239 [ "$gitver" = "$debver" ] ||
240 warn "Git version $gitver doesn't match Debian version $debver"
244 ## Maybe check out a copy of the source.
248 run git clone -sn $srcpath/.git _source
249 assign srcpath $releasepath/_source
251 run git checkout -b mdw-build $checkoutrev
255 ## Maybe refresh the build machinery.
262 ## Initialize the build directory.
263 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
265 assign buildpath $releasepath/_build
268 run $srcpath/configure
271 info "VPATH build disabled"
272 assign buildpath $srcpath
278 info "no configure script"
279 assign buildpath $srcpath
284 ## Discover the release name.
285 cat >find-distdir.mk <<'EOF'
291 $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
293 ## Get a tarball distribution.
296 run make $makeopts distcheck
299 run make $makeopts dist
305 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE; then
306 fail "missing RELEASE file in distribution"
309 run mv $buildpath/$distdir.tar.gz .
310 run gpg -u$(mdw-conf releasekey) -ab -o$distdir.tar.gz.gpg $distdir.tar.gz
312 ## Maybe build the Debian packages.
315 run tar xvfz $distdir.tar.gz
317 run dpkg-buildpackage -k$(mdw-conf releasekey)
321 ## Maybe upload Debian packages.
323 case "$upload,$build" in
325 info "Test build: not uploading."
328 run rsync $distdir.tar.gz $distdir.tar.gz.gpg \
329 $(mdw-conf upload-target ftp.distorted.org.uk:~ftp/pub/mdw/)
332 run dput -f $(mdw-conf dput-target distorted) *.changes
340 rm -rf $releasepath/$distdir
341 rm -rf $releasepath/_source
342 rm -rf $releasepath/_build
349 ###----- That's all, folks --------------------------------------------------